#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <iostream>

std::vector<int>	values;
int					len;
/*
 *			 0
 *		  1     2
 *		3   4 5   6
 *     7 8 9
 *	0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
 *  1 2 3 4 5 6 7
 *  2 3 4 5 6 7 8*/
  bool test_chemin(int i) {
 		if (i >= len)
 			return true;
		else
 		{
			return (values[i] <= values[0] && (test_chemin(i * 2 + 1) || test_chemin(i * 2 + 2)));
 		}
  }


struct node_tree {
	node_tree() : left(NULL), right(NULL){}
	~node_tree() {
		delete left;
		delete right;
	}
	node_tree*	left;
	node_tree*	right;
	int val;
};

/*int					index_v = 0;

node_tree	*construct_tree(int cur, int max) {
	node_tree*	ret;

	if (cur == max)
		return NULL;
	ret = new node_tree();
	ret->left = construct_tree(cur + 1, max);
	ret->right = construct_tree(cur + 1, max);
	return ret;
}

void	assign_keys(node_tree* root) {
	root->val = values[index_v];
	index_v += 1;
	if (root->left) {
		assign_keys(root->left);
		assign_keys(root->right);
	}
}
bool		test_chemin(node_tree* root, int max_val) {
	if (root->left == NULL)
		return (true);
	else
		return ((root->left->val <= max_val && test_chemin(root->left, max_val)) ||
		   (root->right->val <= max_val && test_chemin(root->right, max_val)));
}*/


int main(int ac, char **av) {
	int n, i;
//	node_tree*	root;
	int	sum = 0, perms = 1;

	if (ac == 2)
	{
		n = std::atoi(av[1]);
		len = std::pow(2, n) - 1;
		for (i = 0; i < len; i++)
			values.push_back(i);
//		root = construct_tree(0, n);
//		assign_keys(root);
//		index_v = 0;
		sum += (test_chemin(0) ? 1 : 0);
		while (std::next_permutation(values.begin(), values.end())) {
                std::cout << sum;
//			assign_keys(root);
			perms += 1;
//			index_v = 0;
			sum += (test_chemin(0) ? 1 : 0);
		}
		std::cout << "On a binary tree of depth " << n << ", there is " << sum
			<< " possible ways for all its "<< perms << " permutations." << std::endl;
//		delete root;
	}
}
